defmodule ClickHouse.Utils do
  @moduledoc false

  @spec intersperse_map(list, any, any, any) :: any
  def intersperse_map(list, seperator, mapper, acc \\ [])

  def intersperse_map([], _separator, _mapper, acc), do: acc

  def intersperse_map([elem], _separator, mapper, acc) do
    [acc | mapper.(elem)]
  end

  def intersperse_map([elem | rest], separator, mapper, acc) do
    intersperse_map(rest, separator, mapper, [acc, mapper.(elem), separator])
  end
end
